/*
(C) 2002 Advanced Micro Devices, Inc. 
** YOUR USE OF THIS LIBRARY IS SUBJECT TO THE TERMS 
    AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC 
    LICENSE FOUND IN THE "README" FILE THAT IS INCLUDED WITH 
    THIS LIBRARY**
*/

#include "libm_amd.h"
#include "libm_util_amd.h"

  /* Returns the absolute value of x with the sign of y.
     NaNs are not considered special; their sign bits are handled
     the same as for any other number. */

float __copysignf(float x, float y)
{
  /* This works on Hammer */
  float temp = -0.0; /* 0x80000000 */
  /* AND the bit pattern with y, result in y */
  asm volatile ("andps	%0, %1" : : "x" (temp), "x" (y));
  /* AND the ones-complement of the bit pattern with x, result in temp */
  asm volatile ("andnps	%0, %1" : : "x" (x), "x" (temp));
  asm volatile ("orps	%0, %1" : : "x" (temp), "x" (y));
  return y;
}


weak_alias (__copysignf, copysignf)
