/*
(C) 2002 Advanced Micro Devices, Inc. 
** YOUR USE OF THIS LIBRARY IS SUBJECT TO THE TERMS 
    AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC 
    LICENSE FOUND IN THE "README" FILE THAT IS INCLUDED WITH 
    THIS LIBRARY**
*/

#include "libm_amd.h"
#include "libm_util_amd.h"

/* Returns 0 if x is infinite or NaN, otherwise returns 1 */

int __finite(double x)
{
  /* This works on Hammer */
  double temp = 1.0e444; /* = infinity = 0x7ff0000000000000 */
  volatile int retval;
  retval = 0;
  asm volatile ("andpd	%0, %1;" : : "x" (temp), "x" (x));
  asm volatile ("comisd	%0, %1" : : "x" (temp), "x" (x));
  asm volatile ("setnz	%0" : "=g" (retval));
  return retval;
}

hidden_def (__finite)
weak_alias (__finite, finite)

