# $Header: /K8_Projects/Glibc/amd64memcmp.S 4     10/06/03 10:57 Emenezes $

# (c) 2002 Advanced Micro Devices, Inc.
# YOUR USE OF THIS CODE IS SUBJECT TO THE TERMS
# AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC
# LICENSE FOUND IN THE "README" FILE THAT IS
# INCLUDED WITH THIS FILE

#include "sysdep.h"
#include <rtld-global-offsets.h>

#ifdef PIC
	.globl _rtld_local_ro
        .hidden _rtld_local_ro
        .set    _rtld_local_ro,_rtld_global_ro
#endif

        .text

ENTRY   (memcmp)                        # (const void *, const void*, size_t)

L(memcmptry1):
        cmp     $8, %rdx
        jae     L(memcmp1after)

L(memcmp1):                                # 1-byte
        test    %rdx, %rdx
        mov     $0, %eax
        jz      L(memcmpexit)

L(memcmp1loop):
        movzbl  (%rdi), %eax
        movzbl  (%rsi), %ecx
        sub     %ecx, %eax
        jnz     L(memcmpexit)

        dec     %rdx

        lea     1 (%rdi), %rdi
        lea     1 (%rsi), %rsi

        jnz     L(memcmp1loop)

L(memcmpexit):
        rep
        ret

        .p2align 4

L(memcmp1after):

L(memcmp8try):
        cmp     $32, %rdx
        jae     L(memcmp8after)

L(memcmp8):                        # 8-byte
        mov     %edx, %ecx
        shr     $3, %ecx
        jz      L(memcmp1)

        .p2align 4

L(memcmp8loop):
        mov     (%rsi), %rax
        cmp     (%rdi), %rax
        jne     L(memcmp1)

        sub     $8, %rdx
        dec     %ecx

        lea     8 (%rsi), %rsi
        lea     8 (%rdi), %rdi

        jnz     L(memcmp8loop)

L(memcmp8skip):
        and     $7, %edx
        jnz     L(memcmp1)

        xor     %eax, %eax
        ret

        .p2align 4

L(memcmp8after):

L(memcmp32try):
        cmp     $2048, %rdx
        ja      L(memcmp32after)

L(memcmp32):                               # 32-byte
        mov     %edx, %ecx
        shr     $5, %ecx
        jz      L(memcmp8)

        .p2align 4

L(memcmp32loop):
        mov        (%rsi), %rax
        mov      8 (%rsi),  %r8
        mov     16 (%rsi),  %r9
        mov     24 (%rsi), %r10
        sub        (%rdi), %rax
        sub      8 (%rdi),  %r8
        sub     16 (%rdi),  %r9
        sub     24 (%rdi), %r10

        or      %rax,  %r8
        or       %r9, %r10
        or       %r8, %r10
        jnz     L(memcmp8)

        sub     $32, %rdx
        dec     %ecx

        lea     32 (%rsi), %rsi
        lea     32 (%rdi), %rdi

        jnz     L(memcmp32loop)

L(memcmp32skip):
        and     $31, %edx
        jnz     L(memcmp8)

        xor     %eax, %eax
        ret

        .p2align 4

L(memcmp32after):

#ifdef PIC
        mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov	RTLD_GLOBAL_DL_CACHE1SIZEHALF(%r8), %r9
#else
        mov     _dl_cache1sizehalf, %r9
#endif
	prefetcht0 (%r9)


.alignsrctry:
        mov     %esi, %r8d      # align by source

        and     $7, %r8d
        jz      .alignsrcafter  # not unaligned

.alignsrc:                      # align
        lea     -8 (%r8, %rdx), %rdx
        sub     $8, %r8d

#       .p2align 4

.alignsrcloop:
        movzbl  (%rdi), %eax
        movzbl  (%rsi), %ecx
        sub     %ecx, %eax
        jnz     L(memcmpexit)

        inc     %r8d

        lea     1 (%rdi), %rdi
        lea     1 (%rsi), %rsi

        jnz     .alignsrcloop

        .p2align 4

.alignsrcafter:


L(memcmp64try):
#ifdef PIC
        mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov	RTLD_GLOBAL_DL_CACHE1SIZEHALF(%r8), %rcx
#else
        mov     _dl_cache1sizehalf, %rcx
#endif
        cmp	%rdx, %rcx
        cmova   %rdx, %rcx

L(memcmp64):                               # 64-byte
        shr     $6, %rcx
        jz      L(memcmp32)

        .p2align 4

L(memcmp64loop):
        mov        (%rsi), %rax
        mov      8 (%rsi),  %r8
        sub        (%rdi), %rax
        sub      8 (%rdi),  %r8
        or      %r8,  %rax

        mov     16 (%rsi),  %r9
        mov     24 (%rsi), %r10
        sub     16 (%rdi),  %r9
        sub     24 (%rdi), %r10
        or      %r10, %r9

        or      %r9,  %rax
        jnz     L(memcmp32)

        mov     32 (%rsi), %rax
        mov     40 (%rsi),  %r8
        sub     32 (%rdi), %rax
        sub     40 (%rdi),  %r8
        or      %r8,  %rax

        mov     48 (%rsi),  %r9
        mov     56 (%rsi), %r10
        sub     48 (%rdi),  %r9
        sub     56 (%rdi), %r10
        or      %r10, %r9

        or      %r9,  %rax
        jnz    	L(memcmp32)

        lea     64 (%rsi), %rsi
        lea     64 (%rdi), %rdi

        sub     $64, %rdx
        dec     %rcx
        jnz     L(memcmp64loop)

#       .p2align 4

L(memcmp64skip):
        cmp     $2048, %rdx
        ja     L(memcmp64after)

        test    %edx, %edx
        jnz     L(memcmp32)

        xor     %eax, %eax
        ret

        .p2align 4

L(memcmp64after):

L(memcmppretry):

L(memcmppre):                              # 64-byte prefetching
#ifdef PIC
        mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov	RTLD_GLOBAL_DL_CACHE2SIZEHALF(%r8), %rcx
#else
        mov     _dl_cache2sizehalf, %rcx
#endif
        cmp	%rdx, %rcx
        cmova   %rdx, %rcx

        shr     $6, %rcx
        jz      L(memcmppreskip)

        prefetcht0 512 (%rsi)
        prefetcht0 512 (%rdi)

        mov        (%rsi), %rax
        mov      8 (%rsi), %r9
        mov     16 (%rsi), %r10
        mov     24 (%rsi), %r11
        sub        (%rdi), %rax
        sub      8 (%rdi), %r9
        sub     16 (%rdi), %r10
        sub     24 (%rdi), %r11

        or       %r9, %rax
        or      %r11, %r10
        or      %r10, %rax
        jnz     L(memcmp32)

        mov     32 (%rsi), %rax
        mov     40 (%rsi), %r9
        mov     48 (%rsi), %r10
        mov     56 (%rsi), %r11
        sub     32 (%rdi), %rax
        sub     40 (%rdi), %r9
        sub     48 (%rdi), %r10
        sub     56 (%rdi), %r11

        or       %r9, %rax
        or      %r11, %r10
        or      %r10, %rax
        jnz     L(memcmp32)

        lea     64 (%rsi), %rsi
        lea     64 (%rdi), %rdi

        sub     $64, %rdx
        dec     %rcx

        .p2align 4

L(memcmppreloop):
        prefetcht0 512 (%rsi)
        prefetcht0 512 (%rdi)

        mov        (%rsi), %rax
        mov      8 (%rsi), %r9
        mov     16 (%rsi), %r10
        mov     24 (%rsi), %r11
        sub        (%rdi), %rax
        sub      8 (%rdi), %r9
        sub     16 (%rdi), %r10
        sub     24 (%rdi), %r11

        or       %r9, %rax
        or      %r11, %r10
        or      %r10, %rax
        jnz     L(memcmp32)

        mov     32 (%rsi), %rax
        mov     40 (%rsi), %r9
        mov     48 (%rsi), %r10
        mov     56 (%rsi), %r11
        sub     32 (%rdi), %rax
        sub     40 (%rdi), %r9
        sub     48 (%rdi), %r10
        sub     56 (%rdi), %r11

        or       %r9, %rax
        or      %r11, %r10
        or      %r10, %rax
        jnz     L(memcmp32)

        lea     64 (%rsi), %rsi
        lea     64 (%rdi), %rdi

        sub     $64, %rdx
        dec     %rcx
        jnz     L(memcmppreloop)

#       .p2align 4

L(memcmppreskip):
        cmp     $2048, %rdx
        ja      L(memcmppreafter)

        test    %edx, %edx
        jnz     L(memcmp32)

        xor     %eax, %eax
        ret

        .p2align 4

L(memcmppreafter):

L(memcmp128try):

L(memcmp128):                              # 128-byte
        mov     %rdx, %rcx
        shr     $7, %rcx
        jz      L(memcmp128skip)

        .p2align 4

L(memcmp128loop):
        prefetcht0 512 (%rsi)
        prefetcht0 512 (%rdi)

        mov        (%rsi), %rax
        mov      8 (%rsi), %r8
        sub        (%rdi), %rax
        sub      8 (%rdi), %r8
        mov     16 (%rsi), %r9
        mov     24 (%rsi), %r10
        sub     16 (%rdi), %r9
        sub     24 (%rdi), %r10

        or       %r8, %rax
        or       %r9, %r10
        or      %r10, %rax

        mov     32 (%rsi), %r8
        mov     40 (%rsi), %r9
        sub     32 (%rdi), %r8
        sub     40 (%rdi), %r9
        mov     48 (%rsi), %r10
        mov     56 (%rsi), %r11
        sub     48 (%rdi), %r10
        sub     56 (%rdi), %r11

        or       %r9, %r8
        or      %r11, %r10
        or      %r10, %r8

        or      %r8, %rax
        jnz     L(memcmp32)

        prefetcht0 576 (%rsi)
        prefetcht0 576 (%rdi)

        mov      64 (%rsi), %rax
        mov      72 (%rsi), %r8
        sub      64 (%rdi), %rax
        sub      72 (%rdi), %r8
        mov      80 (%rsi), %r9
        mov      88 (%rsi), %r10
        sub      80 (%rdi), %r9
        sub      88 (%rdi), %r10

        or       %r8, %rax
        or       %r9, %r10
        or      %r10, %rax

        mov      96 (%rsi), %r8
        mov     104 (%rsi), %r9
        sub      96 (%rdi), %r8
        sub     104 (%rdi), %r9
        mov     112 (%rsi), %r10
        mov     120 (%rsi), %r11
        sub     112 (%rdi), %r10
        sub     120 (%rdi), %r11

        or       %r9, %r8
        or      %r11, %r10
        or      %r10, %r8

        or      %r8, %rax
        jnz     L(memcmp32)

        sub     $128, %rdx
        dec     %rcx

        lea     128 (%rsi), %rsi
        lea     128 (%rdi), %rdi

        jnz     L(memcmp128loop)

L(memcmp128skip):
        and     $127, %edx
        jnz     L(memcmp32)

        xor     %eax, %eax
        ret

END     (memcmp)

#undef bcmp
weak_alias (memcmp, bcmp)
