# (c) 2002 Advanced Micro Devices, Inc.
# YOUR USE OF THIS CODE IS SUBJECT TO THE TERMS
# AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC
# LICENSE FOUND IN THE "README" FILE THAT IS
# INCLUDED WITH THIS FILE


#include <sysdep.h>
#include "asm-syntax.h"
#include "bp-sym.h"
#include "bp-asm.h"
#include <rtld-global-offsets.h>

/* BEWARE: `#ifdef memset' means that memset is redefined as `bzero' */
#define BZERO_P (defined memset)

#ifdef PIC
	.globl _rtld_local_ro
        .hidden _rtld_local_ro
        .set    _rtld_local_ro,_rtld_global_ro
#endif

#define LABEL(s) L(memset##s)

        .text
#if !BZERO_P && defined PIC && !defined NOT_IN_libc
ENTRY (__memset_chk)
       cmpq    %rdx, %rcx
       jb      HIDDEN_JUMPTARGET (__chk_fail)
END (__memset_chk)
#endif

ENTRY (memset)                	# (void *, const void*, size_t)

#if BZERO_P
        mov     %rsi, %rdx		# memset doubles as bzero
        xor     %esi, %esi
#else
	mov	$0x0101010101010101, %rcx # memset is itself
        movzx   %sil, %rsi
        imul    %rcx, %rsi		# replicate 8 times
#endif

LABEL(try1):
        cmp     $64, %rdx
        mov     %rdi, %rax		# return memory block address (even for bzero ())
        jae	LABEL(1after)

LABEL(1):                                # 1-byte
        test    $1, %dl
        jz      LABEL(1a)

        mov     %sil, (%rdi)
        inc	%rdi

LABEL(1a):
        test    $2, %dl
        jz      LABEL(1b)

        mov     %si, (%rdi)
        add	$2, %rdi

LABEL(1b):
        test    $4, %dl
        jz      LABEL(1c)

        mov     %esi, (%rdi)
	add	$4, %rdi

LABEL(1c):
        test    $8, %dl
        jz      LABEL(1d)

        mov     %rsi, (%rdi)
	add	$8, %rdi

LABEL(1d):
        test    $16, %dl
        jz      LABEL(1e)

        mov     %rsi,   (%rdi)
        mov     %rsi, 8 (%rdi)
	add	$16, %rdi

LABEL(1e):

        test    $32, %dl
        jz      LABEL(1f)

        mov     %rsi,    (%rdi)
        mov     %rsi,  8 (%rdi)
        mov     %rsi, 16 (%rdi)
        mov     %rsi, 24 (%rdi)
#	add	$32, %rdi

LABEL(1f):

LABEL(exit):
        rep
        ret

        .p2align 4

LABEL(1after):

LABEL(32try):
        cmp     $256, %rdx
        ja     LABEL(32after)

LABEL(32):                               # 32-byte
        mov     %edx, %ecx
        shr     $5, %ecx
        jz      LABEL(32skip)

        .p2align 4

LABEL(32loop):
        dec     %ecx

        mov     %rsi,    (%rdi)
        mov     %rsi,  8 (%rdi)
        mov     %rsi, 16 (%rdi)
        mov     %rsi, 24 (%rdi)

        lea     32 (%rdi), %rdi

        jz      LABEL(32skip)

        dec     %ecx

        mov     %rsi,    (%rdi)
        mov     %rsi,  8 (%rdi)
        mov     %rsi, 16 (%rdi)
        mov     %rsi, 24 (%rdi)

        lea     32 (%rdi), %rdi

        jnz     LABEL(32loop)

        .p2align 4

LABEL(32skip):
        and     $31, %edx
        jnz     LABEL(1)

        rep
        ret

        .p2align 4

LABEL(32after):

#ifdef PIC
	mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov     RTLD_GLOBAL_DL_CACHE1SIZEHALF(%r8), %r9
#else
	mov     _dl_cache1sizehalf, %r9
#endif
	prefetcht0 (%r9)		# improves test further ahead

LABEL(aligntry):
        mov     %edi, %ecx              # align by destination

        and     $7, %ecx                # skip if already aligned
        jz      LABEL(alignafter)

LABEL(align):                            # align
        lea     -8 (%rcx, %rdx), %rdx
        sub     $8, %ecx

        .p2align 4

LABEL(alignloop):
        inc     %ecx

        mov     %sil, (%rdi)
        lea     1 (%rdi), %rdi

        jnz     LABEL(alignloop)

        .p2align 4

LABEL(alignafter):
#ifdef PIC
        mov     _rtld_local_ro@GOTPCREL(%rip), %r9
	mov	RTLD_GLOBAL_DL_CACHE2SIZEHALF(%r9), %r8
	# For MP System half cache size is better, for UP full cache size
	# is better -> use half cache size only
#else
        mov     _dl_cache2sizehalf, %r8
#endif
        cmp     %rdx, %r8
        cmova   %rdx, %r8

LABEL(fasttry):
	cmp	$2048, %rdx		# this is slow for some block sizes
	jb	LABEL(64)

LABEL(fast):				# microcode
	mov	%r8, %rcx
	and	$-8, %r8
	shr	$3, %rcx

	xchg	%rax, %rsi

	rep
	stosq

	xchg	%rax, %rsi

LABEL(fastskip):
	sub	%r8, %rdx
	ja	LABEL(64after)

	and	$7, %edx
	jnz	LABEL(1)

	rep
	ret

	.p2align 4

LABEL(fastafter):

LABEL(64try):

LABEL(64):                               # 64-byte
        mov     %r8, %rcx
        and     $-64, %r8
        shr     $6, %rcx

        dec     %rcx                    # this iteration starts the prefetcher sooner

        mov     %rsi,    (%rdi)
        mov     %rsi,  8 (%rdi)
        mov     %rsi, 16 (%rdi)
        mov     %rsi, 24 (%rdi)
        mov     %rsi, 32 (%rdi)
        mov     %rsi, 40 (%rdi)
        mov     %rsi, 48 (%rdi)
        mov     %rsi, 56 (%rdi)

        lea     64 (%rdi), %rdi

        .p2align 4

LABEL(64loop):
        dec     %rcx

        mov     %rsi,    (%rdi)
        mov     %rsi,  8 (%rdi)
        mov     %rsi, 16 (%rdi)
        mov     %rsi, 24 (%rdi)
        mov     %rsi, 32 (%rdi)
        mov     %rsi, 40 (%rdi)
        mov     %rsi, 48 (%rdi)
        mov     %rsi, 56 (%rdi)

        lea     64 (%rdi), %rdi

        jnz     LABEL(64loop)

LABEL(64skip):
        sub     %r8, %rdx
        ja      LABEL(64after)

	and     $63, %edx
	jnz     LABEL(32)

        rep
        ret

        .p2align 4

LABEL(64after):

LABEL(NTtry):

LABEL(NT):                               # 128-byte
        mov     %rdx, %rcx
        shr     $7, %rcx
        jz      LABEL(NTskip)

        .p2align 4

LABEL(NTloop):                  # on an MP system it would be better to prefetchnta 320 (%rdi) and 384 (%rdi) here, but not so on an 1P system
        dec     %rcx

        movnti  %rsi,     (%rdi)
        movnti  %rsi,   8 (%rdi)
        movnti  %rsi,  16 (%rdi)
        movnti  %rsi,  24 (%rdi)
        movnti  %rsi,  32 (%rdi)
        movnti  %rsi,  40 (%rdi)
        movnti  %rsi,  48 (%rdi)
        movnti  %rsi,  56 (%rdi)
        movnti  %rsi,  64 (%rdi)
        movnti  %rsi,  72 (%rdi)
        movnti  %rsi,  80 (%rdi)
        movnti  %rsi,  88 (%rdi)
        movnti  %rsi,  96 (%rdi)
        movnti  %rsi, 104 (%rdi)
        movnti  %rsi, 112 (%rdi)
        movnti  %rsi, 120 (%rdi)

        lea     128 (%rdi), %rdi

        jnz     LABEL(NTloop)

        sfence

LABEL(NTskip):
        and     $127, %edx
        jnz     LABEL(32)

        rep
        ret

END (memset)
#if !BZERO_P
libc_hidden_builtin_def (memset)
#endif
