# $Header: /K8_Projects/Glibc/amd64strcmp.S 10    2/10/04 11:48 Emenezes $

# (c) 2002 Advanced Micro Devices, Inc.
# YOUR USE OF THIS CODE IS SUBJECT TO THE TERMS
# AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC
# LICENSE FOUND IN THE "README" FILE THAT IS
# INCLUDED WITH THIS FILE

#include "sysdep.h"

#define LABEL(s) L##s

        .text

ENTRY   (strcmp)			# (const char *, const char *)

        xor     %ecx, %ecx

#ifdef USE_AS_STRNCMP			// (const char *, const char *, size_t)
        mov	%r14, -8 (%rsp)
	mov	%rdx, %r14

	test	%rdx, %rdx
	mov	%edx, %eax
	jz	.LABEL(exitz)
#endif

.LABEL(aligntry):
        mov     %rsi, %r8		# align by "source"
        and     $8 - 1, %r8		# between 0 and 8 characters compared
	jz	.LABEL(alignafter)

.LABEL(align):
        sub     $8, %r8

        .p2align 4

.LABEL(alignloop):
        mov     (%rsi, %rcx), %al
        mov	(%rdi, %rcx), %dl

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.LABEL(exitafter)
#endif

        cmp     %dl, %al		# check if same character
        jne     .LABEL(exitafter)
        test    %al, %al		# check if character a NUL
        jz      .LABEL(exitafter)

        inc     %ecx

        inc     %r8
        jnz     .LABEL(alignloop)

        .p2align 4

.LABEL(alignafter):

        mov	%r15, -32 (%rsp)
        mov	%rbp, -24 (%rsp)
        mov	%rbx, -16 (%rsp)

.LABEL(pagealigntry):			# page align by "destination"
	mov	$4096, %r15d		# page size is 4096
        lea	(%rdi, %rcx), %ebp
        and     $4095, %ebp		# page mask
        sub	%r15d, %ebp

.LABEL(64):                              # 64-byte
	mov     $0xfefefefefefefeff, %rbx # magic number

        .p2align 4

.LABEL(64loop):
	add	$64, %ebp		# check if "destination" crosses a page unevenly
	jle	.LABEL(64gobble)

        sub	%r15d, %ebp
        lea	64 (%rcx), %r8

        .p2align 4

.LABEL(64nibble):
        mov     (%rsi, %rcx), %al
        mov	(%rdi, %rcx), %dl

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al		# check if same character
        jne     .exit
        test    %al, %al		# check if character a NUL
        jz      .exit

        inc	%ecx

        cmp	%ecx, %r8d
        ja	.LABEL(64nibble)

        .p2align 4

.LABEL(64gobble):
        mov     (%rsi, %rcx), %rax
        mov     (%rdi, %rcx), %rdx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        mov     8 (%rsi, %rcx), %rax
        mov     8 (%rdi, %rcx), %rdx
        add     $8, %ecx

#ifdef USE_AS_STRNCMP
	sub	$8, %r14
	jl	.LABEL(tail)
#endif

        mov     %rbx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        mov     %rbx, %r9
        add     %rdx, %r9
        sbb     %r11, %r11

        xor     %rax, %r8
        or      %rbx, %r8
        sub     %r10, %r8
        jnz     .LABEL(tail)

        xor     %rdx, %r9
        or      %rbx, %r9
        sub     %r11, %r9
        jnz     .LABEL(tail)

        cmp     %rdx, %rax
        jne     .LABEL(tail)

        add	$8, %ecx

        jmp	.LABEL(64loop)

.LABEL(64after):

.LABEL(tailtry):
#	mov     (%rsi, %rcx), %rax
#	mov     (%rdi, %rcx), %rdx
#	add     $8, %rcx

.LABEL(tail):				# byte tail
#ifdef USE_AS_STRNCMP
	add	$7, %r14
#endif

        cmp     %dl, %al		# check if same character
        jne     .exit
        test    %al, %al		# check if character a NUL
        jz      .exit

        shr	$8, %rax
        shr	$8, %rdx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %rax
        shr	$8, %rdx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %rax
        shr	$8, %rdx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %rax
        shr	$8, %rdx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %eax
        shr	$8, %edx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %eax
        shr	$8, %edx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
        test    %al, %al
        jz      .exit

        shr	$8, %eax
        shr	$8, %edx

#ifdef USE_AS_STRNCMP
	dec	%r14
	jl	.exit
#endif

        cmp     %dl, %al
        jne     .exit
#	test    %al, %al
#	jz      .exit

        .p2align 4,, 15

.LABEL(tailafter):

.exit:
	mov	-32 (%rsp), %r15
	mov	-24 (%rsp), %rbp
        mov	-16 (%rsp), %rbx

        .p2align 4,, 3

.LABEL(exitafter):
#ifdef USE_AS_STRNCMP
	test	%r14, %r14
	cmovl	%edx, %eax
#endif

	movzx	%al, %eax
	movzx	%dl, %edx
	sub	%eax, %edx
	xchg	%edx, %eax

#ifdef USE_AS_STRNCMP
.LABEL(exitz):
	mov	-8 (%rsp), %r14
#endif
        ret

END     (strcmp)
libc_hidden_builtin_def (strcmp)
