# $Header: /K8_Projects/Glibc/amd64strcpy.S 7     2/12/04 19:06 Emenezes $

# (c) 2002 Advanced Micro Devices, Inc.
# YOUR USE OF THIS CODE IS SUBJECT TO THE TERMS
# AND CONDITIONS OF THE GNU LESSER GENERAL PUBLIC
# LICENSE FOUND IN THE "README" FILE THAT IS
# INCLUDED WITH THIS FILE

#include "sysdep.h"
#include <rtld-global-offsets.h>

	/* XXX:	strncpy is broken, just use this for strcpy for now.  */
#ifdef PIC
	.globl _rtld_local_ro
        .hidden _rtld_local_ro
        .set    _rtld_local_ro,_rtld_global_ro
#endif
#ifndef STRCPY
# define STRCPY strcpy
#endif
#define LABEL(s) L(strcpy##s)

        .text

ENTRY   (STRCPY)                        # (char *, const char *)

#ifdef USE_AS_STRNCPY			// (char *, const char *, size_t)
	test	%rdx, %rdx		# (char *, const char *, size_t)
	mov	%rdx, %r11
	jz	LABEL(exitn)		# early exit
#endif

        xor     %edx, %edx

LABEL(aligntry):
        mov     %rsi, %r8		# align by source
        and     $7, %r8
	jz	LABEL(alignafter)

LABEL(align):				# 8-byte align
        sub     $8, %r8

	.p2align 4

LABEL(alignloop):
#ifdef USE_AS_STRNCPY
	dec	%r11
	jl	LABEL(exitn)
#endif

        mov     (%rsi, %rdx), %al       # check if same character
        test    %al, %al                # check if character a NUL
        mov     %al, (%rdi, %rdx)
        jz      LABEL(exit)

        inc     %edx
        inc     %r8
        jnz     LABEL(alignloop)

	.p2align 4

LABEL(alignafter):

LABEL(8try):
        mov     $0xfefefefefefefeff, %rcx

LABEL(8):                               # 8-byte
        mov     (%rsi, %rdx), %rax

LABEL(8loop):
#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

LABEL(8after):

LABEL(64try):
#ifdef PIC
        mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov	RTLD_GLOBAL_DL_CACHE1SIZEHALF(%r8), %r9
#else
        mov     _dl_cache1sizehalf, %r9
#endif


LABEL(64):				# 64-byte

        .p2align 4

LABEL(64loop):
#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        cmp     %r9, %rdx

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        lea     8 (%rdx), %rdx

        jbe     LABEL(64loop)

LABEL(64after):

LABEL(pretry):
#ifdef PIC
	mov     _rtld_local_ro@GOTPCREL(%rip), %r8
	mov	RTLD_GLOBAL_DL_CACHE2SIZEHALF(%r8), %r9
#else
        mov     _dl_cache2sizehalf, %r9
#endif

LABEL(pre):                              # 64-byte prefetch

        .p2align 4

LABEL(preloop):
#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        mov     %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %edx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(tail)

        cmp     %r9, %rdx

        mov     %rax, (%rdi, %rdx)
        prefetcht0 512 + 8 (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        prefetcht0 512 + 8 (%rsi, %rdx)
        lea     8 (%rdx), %rdx

        jb	LABEL(preloop)

        .p2align 4

LABEL(preafter):

LABEL(NTtry):
	sfence

LABEL(NT):				# 64-byte NT

        .p2align 4

LABEL(NTloop):
#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
        mov     8 (%rsi, %rdx), %rax
        add     $8, %rdx

#ifdef USE_AS_STRNCPY
	sub	$8, %r11
	jl	LABEL(tail)
#endif

        mov     %rcx, %r8
        add     %rax, %r8
        sbb     %r10, %r10

        xor     %rax, %r8
        or      %rcx, %r8
        sub     %r10, %r8
        jnz     LABEL(NTtail)

        movnti  %rax, (%rdi, %rdx)
	mov     8 (%rsi, %rdx), %rax
	prefetchnta 768 + 8 (%rsi, %rdx)
        add     $8, %rdx

        jmp     LABEL(NTloop)

        .p2align 4

LABEL(NTtail):
	sfence

        .p2align 4

LABEL(NTafter):

LABEL(tailtry):

LABEL(tail):                             # 1-byte tail
#ifdef USE_AS_STRNCPY
	add	$8, %r11
#endif

        .p2align 4

LABEL(tailloop):
#ifdef USE_AS_STRNCPY
	dec	%r11
	jl	LABEL(exitn)
#endif

        test    %al, %al
        mov     %al, (%rdi, %rdx)
        jz      LABEL(exit)

	inc     %rdx

#ifdef USE_AS_STRNCPY
	dec	%r11
	jl	LABEL(exitn)

	mov	%ah, %al
#endif

        test    %ah, %ah
        mov     %ah, (%rdi, %rdx)
        jz      LABEL(exit)

        inc     %rdx

#ifdef USE_AS_STRNCPY
	dec	%r11
	jl	LABEL(exitn)
#endif

        shr     $16, %rax

        test    %al, %al
        mov     %al, (%rdi, %rdx)
        jz      LABEL(exit)

        inc     %rdx

#ifdef USE_AS_STRNCPY
	dec	%r11
	jl	LABEL(exitn)

	mov	%ah, %al
#endif

        test    %ah, %ah
        mov     %ah, (%rdi, %rdx)
        jz      LABEL(exit)

        shr     $16, %rax
        inc     %rdx

        jmp     LABEL(tailloop)

        .p2align 4

LABEL(tailafter):

LABEL(exit):
#ifdef USE_AS_STRNCPY
	test	%r11, %r11
	mov	%r11, %rcx

#ifdef USE_AS_STPCPY
        lea     (%rdi, %rdx), %r8
#else
        mov     %rdi, %r8
#endif

	jz	2f

	xor	%eax, %eax		# bzero () would do too, but usually there are only a handfull of bytes left
	shr	$3, %rcx
        lea     1 (%rdi, %rdx), %rdi
	jz	1f

	rep	stosq

1:
	mov	%r11d, %ecx
	and	$7, %ecx
	jz	2f

        .p2align 4,, 3

3:
	dec	%ecx
	mov	%al, (%rdi, %rcx)
	jnz	3b

        .p2align 4,, 3

2:
	mov	%r8, %rax
        ret
	
#endif

        .p2align 4

LABEL(exitn):
#ifdef USE_AS_STPCPY
        lea     (%rdi, %rdx), %rax
#else
        mov     %rdi, %rax
#endif

        ret

END (STRCPY)
#if !defined USE_AS_STPCPY && !defined USE_AS_STRNCPY
libc_hidden_builtin_def (STRCPY)
#endif
